// MYOLESERVERIMPL.H : Declaration of the TMyOleServerImpl

#ifndef __MYOLESERVERIMPL_H_
#define __MYOLESERVERIMPL_H_

#include "Server_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TMyOleServerImpl     Implements IMyOleServer, default interface of MyOleServer
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Server.MyOleServer
// Description    : My first Automation Server
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TMyOleServerImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TMyOleServerImpl, &CLSID_MyOleServer>,
  public IDispatchImpl<IMyOleServer, &IID_IMyOleServer, &LIBID_Server>
{
public:
  TMyOleServerImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("Server.MyOleServer");
  DECLARE_DESCRIPTION("My first Automation Server");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TMyOleServerImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TMyOleServerImpl)
  COM_INTERFACE_ENTRY(IMyOleServer)
  COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IMyOleServer
public:
 
  STDMETHOD(get_CurrentTime(DATE* Value));
};

#endif //__MYOLESERVERIMPL_H_
